<?php
@session_start();
################################################################################
### This disclaimer must be kept intact in order to use this product.        ###
################################################################################
### Project: jT CarFramework [http://intersofts.com]
### Author: J. Toshio Taniguchi
### Since: 27.04.2011
### Version: 1.0.0
### Copyrights: J. Toshio Taniguchi
### Contact: j.taniguchi@taniguchi-blog.com
################################################################################
### CONTRIBUTORS
### - none
################################################################################

class publicregister
{
    protected $register_form_status;    // tracks registration process (complete/error)
    protected $_LANG;
    
    /*
     * Constructor -------------------------------------------------------------
     */
    public function publicregister($lang=array())
    {
        // if group session is set, take user to the home page.
        if( isset($_SESSION['log_group']) && $_SESSION['log_group'] != 'public' )
        {
            header("Location: " . BASE_RELATIVE . DEFAULT_HOME_SLUG);
            exit;
        }
        
        // initialize status.
        $this->register_form_status = '';
        
        // set language vars.
        $this->_LANG = $lang;
        
        // if register form is submit, process it.
        if( isset($_POST['regbtn']) )
        {
            $this->processRegisterForm();
        }
    }
    
    /*
     * Process registration form -----------------------------------------------
     * @return void.
     */
    protected function processRegisterForm()
    {
        $name = trim($_POST['nameInput']);
        $email = trim($_POST['emailInput']);
        $pass = trim($_POST['passwordInput']);
        $cpass = trim($_POST['cpassInput']);
        $agb = trim($_POST['termsInput']);
        $security = trim($_POST['securityInput']);
        $res = (int)$_POST['hidres'];
        
        // set registration form session.
        $_SESSION['reg_name'] = $name;
        $_SESSION['reg_email'] = $email;
        
        // unset security session.
        unset($_SESSION['security_question_a']);
        unset($_SESSION['security_question_b']);
        
        // validate fields.
        if( strlen($name) < 5 )
        {
            $this->register_form_status = 'error';
            return;
        }
        
        require_once BASE_CLASS . 'class-utilities.php';
        
        if( !Utilities::checkEmail($email) )
        {
            $this->register_form_status = 'error';
            return;
        }
        
        if( strlen($pass) < 5 || strlen($pass) > 20 )
        {
            $this->register_form_status = 'error';
            return;
        }
        
        if( $pass != $cpass )
        {
            $this->register_form_status = 'error';
            return;
        }
        
        if( $agb != 'accept' )
        {
            $this->register_form_status = 'error';
            return;
        }
        
        if( $security != $res )
        {
            $this->register_form_status = 'error';
            return;
        }
        
        // check if email is already registered.
        require_once BASE_CLASS . 'class-connect.php';
        
        $db = new Connect();
        $db->open();
        
        if( !$sql = @mysql_query("SELECT `email` FROM `register` WHERE `email`='$email'") )
        {
            require_once BASE_CLASS . 'class-log.php';
            
            LogReport::write('Unable to query database at ' . __FILE__ . ':' . __LINE__ . '. ' . mysql_error());
            
            $db->close();
            $this->register_form_status = 'query';
        }
                
        if( @mysql_num_rows($sql) > 0 )
        {
            $db->close();
            $this->register_form_status = 'email';
            return;
        }
        else
        {
            // unset register form session.
            unset($_SESSION['reg_name']);
            unset($_SESSION['reg_email']);
            
            // filter values.
            $email = mysql_real_escape_string($email);
            $name = mysql_real_escape_string($name);
            $passMD5 = md5($pass);
            
            // register the user account.
            if( !$sql = @mysql_query("INSERT INTO `register` (`email`,`password`,`name`,`group`,`creation`,`banned`,`activated`) 
                VALUES ('$email','$passMD5','$name','user','".date('Y-m-d')."','0','0')") )
            {
                require_once BASE_CLASS . 'class-log.php';
            
                LogReport::write('Unable to query database at ' . __FILE__ . ':' . __LINE__ . '. ' . mysql_error());

                $db->close();
                $this->register_form_status = 'query';
                
                return;
            }
            else
            {
                $db->close();
                
                // set send mail message.
                $message = $this->_LANG['SENDEMAIL_MESSAGE_REGISTRATION'];
                $message .= '<a href="'.BASE_SITE.'/activate/?account='.$email.'">' . $this->_LANG['SENDEMAIL_ACTVATE_NOW'] . '</a><br>';
                
                // send activation email to user.
                require_once BASE_CLASS . 'class-sendmail.php';
                
                $send = new SendEmail();
                $send->setEmail($email);
                $send->setMessage($message);
                $send->setSubject($this->_LANG['SENDEMAIL_SUBJECT_LABEL']);
                $send->send();
                
                $this->register_form_status = 'complete';
            }
        }
    }
    
    /*
     * Get registration status -------------------------------------------------
     * @return string.
     */
    public function getRegistrationStatus()
    {
        return $this->register_form_status;
    }
}